
/*
	mp-sem-prodcons.c -- ޥեȤäԾβ
	$Header$
	Start: 1995/03/01 19:54:55
*/

#include <stdio.h>
#include <pthread.h>
#ifdef sun
#define sched_yield thr_yield
#endif


void *consumer_A(void *);
void *producer_A(void *);
void *consumer_B(void *);
void *producer_B(void *);

pthread_t thread_consumer_A,thread_producer_A,
		thread_consumer_B,thread_producer_B;


#define BUFFSIZE 3	/* Хåե礭, ʽǤ N */
int i_p ;		/* 񤭹, ʽǤ i */
int j_c ;		/* ɤ߽Ф, ʽǤ j */

/*
	POSIX thread ˤϥޥեʤΤǡʬǺޤ
 */

typedef struct sem_t {
    int value;
    pthread_mutex_t mutex;  /* ޥեͤ뤿Υå */
    pthread_cond_t cond;    /* Ԥ碌Υ塼뤿ξդѿ */
} sem_t,* sem_ptr;

void sem_init(sem_t *,int);
void sem_v(sem_t *);
void sem_p(sem_t *);

void
sem_init(sem_t *sem,int value) 
{
     pthread_mutex_init(&sem->mutex,NULL);
     pthread_cond_init(&sem->cond,NULL);
     sem->value = value;
}

void
sem_p(sem_t *sem) 
{
    /* ޤvalueߤ뤿lock */
    pthread_mutex_lock(&sem->mutex);
    while(sem->value == 0) {    /* ⤦ĤäƤʤ */
        /* դѿ˼ʬϿơåơ¾
           ץ񸻤ƤΤԤ */
	pthread_cond_wait(&sem->cond,&sem->mutex);
    } 
    /* ʬʬλ񸻤äΤǡݤ */
    sem->value--;
    pthread_mutex_unlock(&sem->mutex);
    /* å */
}

void
sem_v(sem_t *sem) 
{
    /* ޤvalueߤ뤿lock */
    pthread_mutex_lock(&sem->mutex);
    /* 񸻤 */
    sem->value++;
    pthread_mutex_unlock(&sem->mutex);
    /* ¾˻񸻤ԤäƿƤͤСοͤ򵯤 */
    pthread_cond_signal(&sem->cond);
}

sem_t mutex_c ;		/* Դ֤ӽ, ʽǤ a  */
sem_t mutex_p ;		/* Դ֤ӽ, ʽǤ b  */
sem_t rem ;		/* Хåեζ, ʽǤ e */
sem_t count ;		/* ХåեΥǡ, ʽǤ f */
int buffer[BUFFSIZE] ;	/* Хåե */

int nloop = 10 ;	/* 󷫤֤ƻߤ뤫 */

int
main(int ac,char *av[])
{
/* mp_user_main() ϡ̥ץ򣴸ĺ꽪λ롣*/
	j_c = 0 ;
	i_p = 0 ;

	sem_init( &mutex_p,1 );	/* ӽѤΥޥեν */
	sem_init( &mutex_c,1 );	/* ӽѤΥޥեν */
	sem_init( &rem,BUFFSIZE ); /* Хåեζϡ, e=0 */
	sem_init( &count,0 );	/* Хåե϶, f=0 */

	    pthread_create(&thread_consumer_A, NULL, &consumer_A, NULL);
	    pthread_create(&thread_consumer_B, NULL, &consumer_B, NULL);
	    pthread_create(&thread_producer_A, NULL, &producer_A, NULL);
	    pthread_create(&thread_producer_B, NULL, &producer_B, NULL);
	    pthread_join(thread_consumer_A, NULL);
	    pthread_join(thread_consumer_B, NULL);
	    pthread_join(thread_producer_A, NULL);
	    pthread_join(thread_producer_B, NULL);
}

void *
producer_A(void *arg)	/* ԥץ */
{
    int x ;
    int i ;
	x = 0 ;
	fprintf(stderr,"producer_A(): started.\n");
	for( i=0 ; i<nloop ; i++ )
	{
	    sem_p( &rem );	/* ǤΤԤ */
	    sem_p( &mutex_p );	/* Դ֤ӽ */
	    x = i * 2 ;		/* ξ롣*/
	    fprintf(stderr,"producer_A(): put %d.\n", x );
	    buffer[i_p] = x ;	/* Хåե˾ */
	    i_p++ ;		/* i_p = (i_p+1) % BUFFSIZE */
	    if( i_p>=BUFFSIZE )
		i_p = 0 ;
	    sem_v( &mutex_p );	/* Դ֤ӽ */
	    sem_v( &count );	/* 줿Ȥ */
	}
}


void *
producer_B(void *arg)	/* ԥץ */
{
    int x ;
    int i ;
	x = 0 ;
	fprintf(stderr,"producer_B(): started.\n");
	for( i=0 ; i<nloop ; i++ )
	{
	    sem_p( &rem );	/* ǤΤԤ */
	    sem_p( &mutex_p );	/* Դ֤ӽ */
	    x = i * 2 ;		/* ξ롣*/
	    fprintf(stderr,"producer_B(): put %d.\n", x );
	    buffer[i_p] = x ;	/* Хåե˾ */
	    i_p++ ;		/* i_p = (i_p+1) % BUFFSIZE */
	    if( i_p>=BUFFSIZE )
		i_p = 0 ;
	    sem_v( &mutex_p );	/* Դ֤ӽ */
	    sem_v( &count );	/* 줿Ȥ */
	}
}


void *
consumer_A(void *arg)	/* ԥץ */
{

  int x;
  int i;
  x = 0;
  fprintf(stderr,"consumer_A(): started.\n");
  for( i=0 ; i<nloop; i++){
    sem_p( &count);
    sem_p(&mutex_c);

    x = buffer[j_c] ;
    fprintf(stderr,"consumer_A(): get %d.\n",x );

    buffer[i_p] = x;
    j_c++ ;
    if( j_c >= BUFFSIZE) j_c = 0;
    sem_v( &mutex_c);
    sem_v( &rem);
  }

}


void *
consumer_B(void *arg)	/* ԥץ */
{

  int x;
  int i;
  x = 0;
  fprintf(stderr,"consumer_B(): started.\n");
  for( i=0 ; i<nloop; i++){
    sem_p( &count);
    sem_p(&mutex_c);

    x = buffer[j_c] ;
    fprintf(stderr,"consumer_B(): get %d.\n",x );

    buffer[i_p] = x;
    j_c++ ;
    if( j_c >= BUFFSIZE) j_c = 0;
    sem_v( &mutex_c);
    sem_v( &rem);
  }

}