/*
        myls-l.c -- ls -l filename ƎvO
        \[X̏ꏊ: /home/y05/j05002/OS/report1/ex3/myls-l.c
        vO쐬ɗv: 40
*/
#include <sys/types.h>
#include <sys/stat.h>
#include <stdio.h>
#include <pwd.h>
#include <time.h>

main( argc, argv )
    int argc;
    char *argv[];
{
        if( argc != 2 )
        {
            fprintf( stderr,"Usage:%% %s filename \n",argv[0] );
            exit( 1 );
        }
        ls_l( argv[1] );        /* ̓t@C */
}

ls_l( path )
    char *path;
{
    struct stat buf;
        struct tm *ltime;
        char *mon[] = {"Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"};
        char m_print[]={"rwxrwxrwx"}; /* st_modeϊpz */
        int mode[] = {0000400,0000200,0000100,0000040,0000020,0000010,0000004,0000002,0000001}; /* st_modeϊpz */
        int i;

        if ( stat ( path,&buf ) == -1 ) { /* t@C̑擾 */
                perror( path );
                exit(1);
        }

        /* t@C */
        switch ( buf.st_mode & S_IFMT ) {

          case S_IFREG:
                printf("-");
                break;

          case S_IFDIR:
                printf("d");
                break;

          default:
                printf(" ");
                break;

        }

        for(i = 0; i <= 8; i++) { /* st_modepɕϊ */
                if((buf.st_mode & mode[i]) != mode[i]){
                m_print[i]='-';
                        } 
        }

        printf("%s",m_print); /* pɕϊst_mode\ */
        printf(" ");
        printf("%3d ",buf.st_nlink); /* N */
        uid_print(buf.st_uid); /* t@C̏L */
        printf("%7d ",(int)buf.st_size);  /* t@C̑傫 */
        ltime = localtime(&buf.st_mtime); /* 擾Ԃ{Ԃɕϊ */
        printf("%s ",mon[ltime->tm_mon]); /* p\Lɕϊ */
        printf("%2d ",ltime->tm_mday);  /* t */
        printf("%2d:",ltime->tm_hour);   /*  */
        printf("%2d ",ltime->tm_min);   /*  */
     printf("%s\n",path);
}

/*
struct stat  st_uid tB[hɂ́Auid ĂB𐔒lƂ
Ăł͂ȂAOCƂĕ\邽߂ɂ́Å֐ uid_print() 
gƂ悢B́Auid_t ^iunsigned shortjłB
*/

uid_print( uid )
    uid_t uid ; /* unsigned short, in <sys/types.h > */
{
    struct passwd *pwd ;
        pwd = getpwuid( uid );
        if( pwd == NULL )
            printf("%d ",uid );
        else
            printf("%s ", pwd->pw_name );
}
