/*
        dir-lookup2.c -- Ϳ줿ե̾顢iΡֹĴ٤ץ
        ξ: /home/y05/j05002/OS/report1/ex7/dir-lookup2.c
        ץפ: 230ʬ
*/
#include <stdio.h>/* stderr */
#include <fcntl.h>/* open(2) */
#include <sys/stat.h>
#include <sys/types.h>/* getdents(2) */
#include <sys/dirent.h>/* getdents(2) */
#include <stdlib.h>
#define BUFFSIZE        1024

extern char *malloc();

main( argc, argv )
    int argc;
    char *argv[];
{

  int i = 0, j = 0, k = 0;
  char name[15][255]; /* argv Ǽ */

  if( argc != 2 ) {
    fprintf( stderr,"Usage:%% %s dirname/filename?n",argv[0] );
    exit( 1 );
  }
  
  if ( argv[1][0] == '/' ) {
    chdir( "/" );
    i ++;
  }
  
  for( i ; i <= strlen(argv[1])-1; i++ ) {
    if ( argv[1][i] == '/' ) { 
      j++;
	  k = 0;
	  chdir( name[j] );
    }
    else {
      name[j][k] = argv[1][i];
      k++;
	}
  }
	
  k = 0;
  if ( argv[1][i-1] == '/' ) { /* ⤷ argv[1] κǸΣʸ/פʤ */
	k = j-2 ;
  }
  else {
    k = j -1 ;
  }
  
  for( j = 0; j <= k; j++ ) {
    if( chdir( name[j] ) == -1) {
      perror(name[j]);
      exit(1);
    }
  }

    dir_lookup( name[j-1], name[j] );

}

dir_lookup( dirname, filename )
    char *dirname;
    char *filename;
{
  struct stat dir;
  struct stat fil;
  int fd ;
  struct dirent *p ;
  char *buff ;
  int rcount ;
  long pointer;
  int flag = 0;

  chdir( "../" );
  if ( lstat ( dirname, &dir ) == -1 ) {
    perror( dirname );
    exit(1);
  }

  if ( S_ISDIR(dir.st_mode) ) {  
    flag = 1;
  }

  else {   /* ǥ쥯ȥǤʤХ顼å */
    fprintf( stderr, "%s is not directory \n",dirname);
  }
  
  chdir(dirname);
  if ( lstat ( filename, &fil ) == -1 ) {   /* argv[2]° */
    perror( filename );
    exit(1);
  }

  if ( ! S_ISREG(fil.st_mode) ) {  /* ե̾ʤХ顼å */
    fprintf( stderr, "%s is not filename \n", filename);
    exit(1);
  }
  
  if ( flag == 1 ) {
    chdir("../");
    fd = open( dirname,O_RDONLY );
    if( fd == -1 ) {
      perror( dirname );
      exit( 1 );
    }

    buff = malloc( BUFFSIZE );
    if( buff == 0 ) {
      perror("memory");
      exit( 1 );
    }

    while((rcount=getdirentries(fd, buff, BUFFSIZE, &pointer))>0) {
      for( p = (struct dirent *)buff ; (char *)p < &buff[rcount] ;
	   p=(struct dirent *) ((int)p+(p->d_reclen)) ) {
	if ( strcmp(filename, p->d_name ) == 0 ) {
	  printf("ino : %d     ",fil.st_ino);
	  printf("path: %s\n",p->d_name);
	}

      }
    }

    close( fd );
    free ( buff );

  }
}
