/*
 * Stat.java
 * path:/home/y05/j05002/OS/report2/fileExample/Stat.java
 * CreateTime:1 days
 */

package fileExample;
import java.io.*;
import java.util.*;



    public class Stat {
	    
	    public static void main(String args[]) throws IOException {
		    
		    File file;
		    
		    System.out.println(args[0]);
		    file = new File(args[0]);
		    if (! file.exists()) {
			    System.out.println(" does not exist.");
			    return;
		    }
		    printStat(file,System.out);
		    
	    }
	    
	    public static void printStat(File file,PrintStream out) {
	    
	    
		    out.println(file.getAbsolutePath());
		    if (file.isDirectory()) {
			    out.println(" isDirectory");
		    }
		    if (file.canRead()) {
			    out.println(" can read");
		    } else {
			    out.println(" cannot read");
		    }	
		    if (file.canWrite()) {
			    out.println(" can write");
		    } else {
			    out.println(" cannot write");
		    }
		    out.print("length = "); out.print(file.length()); out.println();
		    out.print("last modified = ");
		

		    Calendar Cal=Calendar.getInstance();
		    Cal.setTimeInMillis(file.lastModified());
		    out.println(Cal.getTime().toString());
		     
	    }
	    
    }