#include <stdio.h>
#include <sys/mman.h>
#include <sys/types.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <unistd.h>
#include <stdlib.h>

int
main(int ac,char *av[])
{
 
  int from = -1 ;
  int to = -1 ;
  caddr_t from_mmap;
  size_t size;

  int map = MAP_PRIVATE;
  struct stat sb;

  if(ac!=3) {
    fprintf(stderr,"Usage: %s from_file to_file",av[0]);
    exit(1);
  }
  if((from=open(av[1],O_RDONLY)) == -1) { //* ѹ 0-1
    fprintf(stderr,"can't open %s\n",av[1]);
    perror(NULL);
  }
  if(fstat(from, &sb)) {
    fprintf(stderr,"can't fstat %s\n",av[1]);
  }
  size = sb.st_size;

  from_mmap = mmap(NULL,size,PROT_READ,map,from,(off_t)0);
  if(from_mmap==MAP_FAILED) { //* ѹ ( (caddr_t)-1  MAP_FAILED )
    fprintf(stderr,"Can't mmap from\n");
    perror(NULL);
    exit(1);
  }
  if((to=open(av[2],O_CREAT|O_WRONLY, 0666))== -1) { //* ѹ (0  -1)
    fprintf(stderr,"can't open %s\n",av[2]);
    perror(NULL);
  }
  if(size==0) { exit(1); }

  //* madvise():Ѥ˴ؤ륢ɥХ򥫡ͥͿ
  //* MADV_WILLNEED:ᤤ襢(⤷ʤ)
  //* sizeХȤΥ꤬줽ȤȤ
  
  if((madvise(from_mmap,size,MADV_WILLNEED))==-1) {
    fprintf(stderr,"Can't use madvise\n");
    perror(NULL);
  }
  
  // memcpy()msync()  write Ȥ 
  write(to, from_mmap, size);


  if(ftruncate(to, (off_t)size)==-1) {
    fprintf(stderr,"Can't ftruncate\n");
    perror(NULL);
  }
  return 1;
}
