#include <stdio.h>
#include <time.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/select.h>
#include <signal.h>
#include "keys.h"

const int noecho = 1 ;

int
main(int ac,char *av[])
{
    int c;
    double time;
    fd_set readers,readfds;
    struct keytype key;
    struct timeval timeout;
    struct timeval ori_tp;

    if (noecho) system("stty raw -echo");
    FD_SET(STDIN,&readers);

    //* λ
    gettimeofday(&ori_tp,0);
    
    for(;;) {
        readfds = readers;

	timeout.tv_sec = 2; //* ॢȤ 2
	timeout.tv_usec = 0;

        c = select(1,&readfds,(fd_set *)0,(fd_set *)0,
		   &timeout);

	//* ϤԤ줺 timeout äȼ¹
	if(c==0){
	  time = (key.tp.tv_sec + (double)key.tp.tv_usec*1e-6)
	    -(ori_tp.tv_sec + (double)ori_tp.tv_usec*1e-6);  
	  fprintf (stderr, "\n\rtime: %10.6f\n\r", time);
	}

	if (c<0) return 1;
	if (! FD_ISSET(0,&readers)) return 2;
	c=read(STDIN,key.buf,1);
	if (c<=0) return 3;
	gettimeofday(&key.tp,0);
	write(STDOUT,&key,sizeof(key));
	if (noecho) write(STDERR,&key.buf[0],1);
	if (key.buf[0]==4) return 0; /* ^D */
    }
    return 0;
}
