#!/usr/bin/perl -w
# pipe2 - bidirectional communication using socketpair
#   "the best ones always go both ways"

use Socket;
use IO::Handle;     # thousands of lines just for autoflush :-(
# We say AF_UNIX because although *_LOCAL is the
# POSIX 1003.1g form of the constant, many machines
# still don't have it.

#g̑o\Pbg𐶐
socketpair(CHILD, PARENT, AF_UNIX, SOCK_STREAM, PF_UNSPEC)
			   or  die "socketpair: $!";

#f[^obt@OȂ悤ɂ
CHILD->autoflush(1);
PARENT->autoflush(1);

#vZX̐
if ($pid = fork) {
#evZX̏
#PARENT
   close PARENT;
   
#CHILDɃbZ[W𑗐M
   print CHILD "Parent Pid $$ is sending this\n";
   
#CHILDMbZ[W̉s菜
   chomp($line = <CHILD>);
   print "Parent Pid $$ just read this: `$line'\n";
   
#CHILDAqvZX̏I҂
   close CHILD;
   waitpid($pid,0);
} else {
#qvZX̏
   die "cannot fork: $!" unless defined $pid;
   
#CHILD
   close CHILD;
   
#PARENTMbZ[W̉s菜
   chomp($line = <PARENT>);
   print "Child Pid $$ just read this: `$line'\n";
   print PARENT "Child Pid $$ is sending this\n";
   
#PARENT
   close PARENT;
   exit;
}

