#!/usr/bin/perl -w
require 5.002;
use strict;
use Socket;
my ($remote,$port, $iaddr, $paddr, $proto, $line);

$remote  = shift || 'pw002.st.ie.u-ryukyu.ac.jp';
$port    = shift || 2345;  # random port
if ($port =~ /\D/) { $port = getservbyname($port, 'tcp') }
die "No port" unless $port;
$iaddr   = inet_aton($remote)               || die "no host: $remote";
$paddr   = sockaddr_in($port, $iaddr);

$proto   = getprotobyname('tcp');

my $pid;

socket(SOCK, PF_INET, SOCK_STREAM, $proto)  || die "socket: $!";
connect(SOCK, $paddr)    || die "connect: $!";

($port,$iaddr) = sockaddr_in($paddr);
my $name = gethostbyaddr($iaddr,AF_INET);

select(SOCK); $|=1;
select(STDOUT); $|=1;

print "login <$name [",inet_ntoa($iaddr),"]>\n";

unless(defined ($pid = fork())) {
    die "cannot fork: $!";
} elsif($pid == 0) {
    while(1) {
	print "-> ";
	$line = <>;
	print SOCK "$line";
    }
} else {
    while(<SOCK>) {
	chomp($_);
	if("" eq $_) {}
	else {
	    print "\n$name: $_\n \n> ";
	}
    }
    waitpid($pid,0);
}
close (SOCK) || die "close: $!";
exit;
