/*
        dir-lookup.c -- ǥ쥯ȥƤ򸡺ץ
        ξ: /home/y05/j05002/OS/report1/ex6/dir-lookup.c
        ץפ: 140ʬ
*/
#include <stdio.h>	/* stderr */
#include <fcntl.h>	/* open(2) */
#include <sys/stat.h>
#include <sys/types.h>	/* getdents(2) */
#include <sys/dirent.h>	/* getdents(2) */
#include <stdlib.h>
#define BUFFSIZE        1024

extern char *malloc();

main( argc, argv )
int argc;
char *argv[];
{
	if( argc != 3 )
	{
	    fprintf( stderr,"Usage:%% %s dirname filename\n",argv[0] );
	    exit( 1 );
	}
	dir_lookup( argv[1], argv[2] );
}

dir_lookup( dirname, filename )
    char *dirname;
    char *filename;
{
    struct stat dir;
	struct stat fil;
	int fd ;
	struct dirent *p ;
	char *buff ;
	int rcount ;
	long pointer;
	int flag = 0;

	
	if ( lstat ( dirname, &dir ) == -1 ) { /* argv[1]° */
		perror( dirname );
		exit(1);
	}

	if ( S_ISDIR(dir.st_mode) ) {  
		flag = 1;
	}

	else {   /* ǥ쥯ȥǤʤХ顼å */
		fprintf( stderr, "%s is not directory \n",dirname);
	}

	
	chdir(dirname);
	if ( lstat ( filename, &fil ) == -1 ) {   /* argv[2]° */
		perror( filename );
		exit(1);
	}

	if ( ! S_ISREG(fil.st_mode) ) {  /* ե̾ʤХ顼å */
		fprintf( stderr, "%s is not filename \n", filename);
		exit(1);
	}

	
	if ( flag == 1 ) {
		chdir("../");
		fd = open( dirname,O_RDONLY );
		if( fd == -1 ) {
			perror( dirname );
			exit( 1 );
		}

		buff = malloc( BUFFSIZE );
		if( buff == 0 ) {
			perror("memory");
			exit( 1 );
		}

		while((rcount=getdirentries(fd, buff, BUFFSIZE, &pointer))>0)  {
			for( p = (struct dirent *)buff ; (char *)p < &buff[rcount] ;
			p=(struct dirent *) ((int)p+(p->d_reclen)) ) {
				if ( strcmp(filename, p->d_name ) == 0 ) {
					printf("ino : %d     ",fil.st_ino);
					printf("path: %s\n",p->d_name);
				}

			}
		}

		close( fd );
		free ( buff );

	}
}
