/*
 * FileSort.java
 * path:/home/y05/j05002/OS/report2/fileExample/FileSort.java
 * CreateTime:2 days
 */

package fileExample;
import java.io.*;
import java.util.*;



    public class FileSort {
	    
	    public static void main(String args[]) throws IOException {
		    
		    File file;
		    		    
		    String opt = args[0];
		    
   		    System.out.println("option = " + args[0]);
		    System.out.println("dir = " + args[1]);
		    
		    
		    file = new File(args[1]);
		    if (! file.exists()) {
			    System.out.println(" does not exist.");
			    return;
		    }
		    Sort(file,opt);
		    
	    }
	    
	    public static void Sort(File file,String opt){
	    	
	    	File[] filelist = file.listFiles();
	    	int filecount = filelist.length;
	    	
	    	/*Sort*/
	    	//sort by name
	    	if(opt.equals("n")){
	    		Arrays.sort(filelist);
	    		for (int i=0; i<filecount; i++){
	    			printStat(filelist[i]);
	    		}
	    	}	    	
	    	//sort by size
	    	else if(opt.equals("s")){
	    		long[] filesize;
             filesize = new long[filecount];

	    		for (int i=0; i<filecount; i++){
	    		    filesize[i] = filelist[i].length();
	    		}
	    		
	    	    Arrays.sort(filesize);
	    	    
	    		for (int i=0; i<filecount; i++){
	    			for (int j=0; j<filecount; j++){
	    				if(filelist[j].length() == filesize[i]){
	    					printStat(filelist[j]);
	    				}
	    			}
	    		}
	    		
	    	}
	    }	    	
	    
	    
	    public static void printStat(File file) {
	    
	    
		    /*type*/
		    if (file.isDirectory()) {
		    	System.out.print(" d ");
		    } else {
		    	System.out.print(" f ");
		    }
		    
		    /*mode*/
		    if (file.canRead()) {
		    	System.out.print("r");
		    } else {
		    	System.out.print("-");
		    }	
		    if (file.canWrite()) {
		    	System.out.print("w ");
		    } else {
		    	System.out.print("- ");
		    }
		    
		    //size
		    System.out.print(file.length());
		    System.out.print("  ");
		

		    //last modisied
		    Calendar Cal=Calendar.getInstance();
		    Cal.setTimeInMillis(file.lastModified());
		    System.out.print(Cal.getTime().toString());
		    System.out.print("  ");
		    
		    //name
		    System.out.println(file.getName());
		    
	    }
	    
    }
    