/*
 * GUIStat.java
 * path:/home/y05/j05002/OS/report2/fileExample/GUIStat.java
 * CreateTime:1 days
 */

package fileExample;
import java.io.*;
import java.util.Calendar;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class GUIStat {

	public static void main(String[] args){
		JFrame Frame = new JFrame("Stat");
		Container Cnt = Frame.getContentPane();
		Cnt.setLayout(new BorderLayout());
		
		/*make Button*/
		final JButton Btn = new JButton("Select");
		final JFileChooser Cho = new JFileChooser("/");
		Cho.setDialogTitle("File Select");
		Cho.setDialogType(JFileChooser.CUSTOM_DIALOG);
		Cnt.add("South",Btn);
		
		/*make Txtbox*/
		//path
		final JTextField path = new JTextField("path",15);
		Cnt.add("North",path);
		//can read?
		final JTextField cr = new JTextField("read",10);
		Cnt.add("West",cr);
		//can write?
		final JTextField cw = new JTextField("write",10);
		Cnt.add("Center",cw);
		//last modified time
		final JTextField lmt = new JTextField("last modified time",20);
		Cnt.add("East",lmt);
		
		/*Setting close*/
		Frame.addWindowListener(
				new WindowAdapter(){
					public void WindowClosing(WindowEvent e){
						System.exit(0);
					}
				}
		);
		
		Btn.addActionListener(
			new ActionListener(){
				public void actionPerformed(ActionEvent e){
					int Rtn = Cho.showOpenDialog(null);
					File file = Cho.getSelectedFile();
					if (Rtn == JFileChooser.APPROVE_OPTION){
						
						path.setText(file.getAbsolutePath() + "\n");
						
					    if (file.canRead()) {
					    	cr.setText("can read");
					    } else {
					    	cr.setText("can't read");
					    }	
					    if (file.canWrite()) {
					    	cw.setText("can write \n");
					    } else {
					    	cw.setText("can't write \n");
					    }
						
					    Calendar Cal=Calendar.getInstance();
					    Cal.setTimeInMillis(file.lastModified());
					    lmt.setText(Cal.getTime().toString());
						
					}
				}
			}
		
		);
		
		Frame.setSize(500,200);
		Frame.setVisible(true);
		
	}
	
}
