package processExample;

import java.util.Timer;
import java.util.TimerTask;

public class ThreadProdCons {

		
	static public void main(String [] args) throws InterruptedException {
		
		/*set Timer*/
		long timeout = 1000;//10000ms
    		long repray = 100;//100ms
    		TimeOut tOut = new TimeOut();
    		Timer timer = new Timer();
    		timer.schedule(tOut,timeout,repray);
		
		
		OurThreadMonitor monitor = new OurThreadMonitor("m1",5);
		OurThreadMonitor monitor2 = new OurThreadMonitor("m2",5);
		OurThreadMonitor monitor3 = new OurThreadMonitor("m3",5);
		
		Thread p1 = new OurProducer("p1",10,monitor);
		Thread c1 = new OurConsumer("c1",monitor);
		Thread p2 = new OurProducer("p2",10,monitor2);
		Thread c2 = new OurConsumer("c2",monitor2);
		Thread c3 = new OurConsumer("c2",monitor3);
		
		monitor.start();
		monitor2.start();
		monitor3.start();
		
		p1.start();
		p2.start();
		c1.start();
		c2.start();
		c3.start();
		
		p1.join();
		p2.join();
		
		c1.join(100);
		c2.join(100);
		c3.join(100);
		
		c1.stop();
		c2.stop();
		c3.stop();
		
		monitor.stop();
		monitor2.stop();
		monitor3.stop();
		
		//System.exit(0);
	}
}

class TimeOut extends TimerTask {
	
	public void run(){
		System.out.println("Dead Lock and TimeOut");
		System.exit(1);
	}
	
}